/*
 *   ORXONOX - the hottest 3D action shooter ever to exist
 *                    > www.orxonox.net <
 *
 *
 *   License notice:
 *
 *   This program is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU General Public License
 *   as published by the Free Software Foundation; either version 2
 *   of the License, or (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 *
 *   Author:
 *      Gani Aliguzhinov
 *   Co-authors:
 *      ...
 *
 */

#ifndef _MasterController_H__
#define _MasterController_H__

#include "controllers/FightingController.h"
#include "tools/interfaces/Tickable.h"



namespace orxonox
{
    class _OrxonoxExport MasterController : public FightingController, public Tickable
    {
        public:
            //----[language demanded functions]----            
                MasterController(Context* context);

                virtual ~MasterController();
            //----[/language demanded functions]----            

            //----[orxonox demanded functions]----
                virtual void tick(float dt); 

            //----[orxonox demanded functions]----

        protected:
          
        private:
            std::vector<WeakPtr<FightingController> > controllers_;
            size_t indexOfCurrentController_;
            unsigned int numberOfTicksPassedSinceLastActionCall_;
            unsigned int ticks_;     //<! local tick counter            

    };
}

#endif /* _MasterController_H__ */
